#include "stdafx.h"
#include "MSMQWrappers.h"
#include <array>


int _tmain()
{
  HRESULT hr{CoInitialize(nullptr)}; //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));

  //Test out the MSMQ::CQueue class

  std::array<QUEUEPROPID, 2> aQueuePropId{PROPID_Q_PATHNAME, PROPID_Q_LABEL};
  std::array<MQPROPVARIANT, 2> aQueuePropVar;
#pragma warning(suppress: 26446 26482)
  aQueuePropVar[0].vt = VT_LPWSTR;
  ATL::CAtlStringW sPath{L".\\Private$\\MSMQDemo"};
#pragma warning(suppress: 26446 26482)
  aQueuePropVar[0].pwszVal = sPath.GetBuffer();
#pragma warning(suppress: 26446 26482)
  aQueuePropVar[1].vt = VT_LPWSTR;
#pragma warning(suppress: 26446)
  ATL::CAtlStringW sLabel{L"Test Queue for MSMQDemo"};
#pragma warning(suppress: 26446 26482)
  aQueuePropVar[1].pwszVal = sLabel.GetBuffer();
  MQQUEUEPROPS queueProps{};
  queueProps.cProp = 2;
  queueProps.aPropID = aQueuePropId.data();
#pragma warning(suppress: 26485)
  queueProps.aPropVar = aQueuePropVar.data();
  std::array<HRESULT, 2> aQueueStatus{};
  queueProps.aStatus = aQueueStatus.data();
  MSMQ::String sFormatName;
  MSMQ::CQueue q1;

  hr = q1.PathNameToFormatName(L".\\Private$\\MSMQDemo", sFormatName);
  if (SUCCEEDED(hr))
    hr = q1.Delete(sFormatName.c_str()); //NOLINT(clang-analyzer-deadcode.DeadStores)
  hr = q1.Create(&queueProps, sFormatName); //NOLINT(clang-analyzer-deadcode.DeadStores)
  sLabel.ReleaseBuffer();
  sPath.ReleaseBuffer();
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));
  hr = q1.Open(sFormatName.c_str(), MQ_RECEIVE_ACCESS | MQ_ADMIN_ACCESS); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));
  q1.Attach(q1.Detach());
  MSMQ::CQueue q3{q1.Detach()};
  MSMQ::CQueue q4;
  hr = q4.Open(sFormatName.c_str(), MQ_SEND_ACCESS); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));
  hr = q4.GetFormatName(sFormatName); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));
  hr = q3.Purge(); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));
  MSMQ::CQueue q5;

  QUEUEPROPID propId2{};
  propId2 = PROPID_Q_INSTANCE;
  MSMQ::CPropVariantAutoFree propVar2;
  MQQUEUEPROPS queueProps2;
  queueProps2.cProp = 1;
  queueProps2.aPropID = &propId2;
  queueProps2.aPropVar = &propVar2;
  HRESULT aQueueStatus2{S_OK};
  queueProps2.aStatus = &aQueueStatus2;
  hr = MQGetQueueProperties(sFormatName.c_str(), &queueProps2); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));
  if (propVar2.puuid != nullptr)
#pragma warning(suppress: 26489 26486)
    hr = MSMQ::CQueue::InstanceToFormatName(*propVar2.puuid, sFormatName); //NOLINT(clang-analyzer-deadcode.DeadStores)
  MSMQ::String sFormatName2;
  hr = MSMQ::CQueue::ADsPathToFormatName(L"NEED an AD Path here", sFormatName2); //NOLINT(clang-analyzer-deadcode.DeadStores)

  std::array<QUEUEPROPID, 2> propId3{PROPID_M_LABEL, PROPID_M_BODY};
  std::array<ATL::CComPropVariant2, 2> propVar3{};
  ATL::CAtlStringW sLabel2{L"This is the label"};
#pragma warning(suppress: 26446)
  propVar3[0] = ATL::CComPropVariant2{sLabel2.GetBuffer(), VT_LPWSTR};
  ATL::CAtlStringA sBody{"This is the body"};
#pragma warning(suppress: 26446 26472 26490)
  propVar3[1] = ATL::CComPropVariant2{reinterpret_cast<BYTE*>(sBody.GetBuffer()), static_cast<ULONG>(sBody.GetLength())};
  MQMSGPROPS msgProps{};
  msgProps.cProp = 2;
  msgProps.aPropID = propId3.data();
  msgProps.aPropVar = propVar3.data();
  std::array<HRESULT, 2> aQueueStatus3{};
  msgProps.aStatus = aQueueStatus3.data();
  hr = q4.Send(&msgProps); //NOLINT(clang-analyzer-deadcode.DeadStores)
  sBody.ReleaseBuffer();
  sLabel2.ReleaseBuffer();
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));

  std::array<QUEUEPROPID, 4> propId4{PROPID_M_LABEL, PROPID_M_LABEL_LEN, PROPID_M_BODY, PROPID_M_BODY_SIZE};
  std::array<ATL::CComPropVariant2, 4> propVar4;
  std::array<wchar_t, 1024> wszLabel2;
#pragma warning(suppress: 26446)
  propVar4[0] = ATL::CComPropVariant2{wszLabel2.data()};
#pragma warning(suppress: 26446 26472)
  propVar4[1] = ATL::CComPropVariant2{static_cast<unsigned long>(wszLabel2.size())};
  std::array<BYTE, 1024> byReceivedBody;
#pragma warning(suppress: 26446 26472)
  propVar4[2] = ATL::CComPropVariant2{byReceivedBody.data(), static_cast<ULONG>(byReceivedBody.size())};
#pragma warning(suppress: 26446 26472)
  propVar4[3] = ATL::CComPropVariant2{static_cast<unsigned long>(byReceivedBody.size())};
  MQMSGPROPS msgProps2{};
  msgProps2.cProp = 4;
  msgProps2.aPropID = propId4.data();
  msgProps2.aPropVar = propVar4.data();
  std::array<HRESULT, 4> aQueueStatus4{};
  msgProps2.aStatus = aQueueStatus4.data();
  hr = q3.Receive(INFINITE, MQ_ACTION_PEEK_CURRENT, &msgProps2); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));

#pragma warning(suppress: 26446)
  wszLabel2[0] = L'\0';
  for (auto& c : byReceivedBody)
    c = 0;
  hr = q3.ReceiveByLookupId(0, MQ_LOOKUP_PEEK_FIRST, &msgProps2); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));

  MSMQ::String sSubQueue{sFormatName};
  sSubQueue += L";reject";
  MSMQ::CQueue q6;
  hr = q6.Open(sSubQueue.c_str(), MQ_MOVE_ACCESS); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));
  hr = q3.Move(q6, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)

  hr = q3.MarkRejected(0); //NOLINT(clang-analyzer-deadcode.DeadStores)

  MGMTPROPID propId5{PROPID_MGMT_MSMQ_ACTIVEQUEUES};
  MSMQ::CPropVariantAutoFree propVar5;
  MQMGMTPROPS mgmtProps5{};
  mgmtProps5.cProp = 1;
  mgmtProps5.aPropID = &propId5;
  mgmtProps5.aPropVar = &propVar5;
  HRESULT amgmtStatus5{S_OK};
  mgmtProps5.aStatus = &amgmtStatus5;
  hr = MQMgmtGetInfo(nullptr, L"MACHINE", &mgmtProps5); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));

  //Test out the cursor class
  MSMQ::CCursor c1;
  hr = c1.Create(q3); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));
  MSMQ::CCursor c2;
  c2.Attach(c2.Detach());
  HANDLE hCursor{c2};
  UNREFERENCED_PARAMETER(hCursor);
  MSMQ::CCursor c3;
  MSMQ::CCursor c4{c3.Detach()};

  //Test out the security context class
  MSMQ::CSecurityContext sc1;
  MSMQ::CSecurityContext sc2{sc1.Detach()};
  MSMQ::CSecurityContext sc3;
  HANDLE hSC{sc3};
  UNREFERENCED_PARAMETER(hSC);
  hr = sc2.Get(nullptr, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));

  //Test out the CSearch class
  MSMQ::CSearch s1;
  MSMQ::CSearch s2{s1.Detach()};
  MSMQ::CSearch s3;
  HANDLE hSearch{s3};
  UNREFERENCED_PARAMETER(hSearch);
  MQCOLUMNSET mqcs{};
  PROPID pid{PROPID_Q_PATHNAME};
  mqcs.cCol = 1;
  mqcs.aCol = &pid;
  MQSORTSET sortSet{};
  sortSet.cCol = 1;
  MQSORTKEY sortKey{};
  sortKey.dwOrder = 1;
  sortKey.propColumn = PROPID_Q_PATHNAME;
  sortSet.aCol = &sortKey;
  hr = s2.LocateBegin(nullptr, &mqcs, &sortSet);
  if (SUCCEEDED(hr))
  {
    DWORD dwProps{13};
    do
    {
      //Note the use of CPropVariantAutoFree which obviates the need to call MQFreeMemory for each propvariant manually
      std::array<MSMQ::CPropVariantAutoFree, 13> aPropVar;
      hr = s2.LocateNext(&dwProps, aPropVar.data()); //NOLINT(clang-analyzer-deadcode.DeadStores)
    }
    while (dwProps > 0);

    hr = s2.LocateEnd(); //NOLINT(clang-analyzer-deadcode.DeadStores)
  }

  //Test out the CComPropVariant class
  ATL::CComPropVariant pv1;
  ATL::CComPropVariant pv2{true};
  hr = pv2.ChangeType(VT_I4); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));
  ATL::CComPropVariant pv3{1};
  try
  {
    //ATL::CComPropVariant pv4{1, VT_DATE}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }
  ATL::CComPropVariant pv5{'c'};
#pragma warning(suppress: 26472)
  ATL::CComPropVariant pv6{static_cast<BYTE>(1)};
  bool bResult = (pv5 == pv6); //NOLINT(clang-analyzer-deadcode.DeadStores, clang-diagnostic-unused-but-set-variable)
  bResult = (pv5 != pv6); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bResult = (pv5 > pv6); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bResult = (pv5 < pv6); //NOLINT(clang-analyzer-deadcode.DeadStores)
  ATL::CComPropVariant pvnull;
  pvnull.vt = VT_NULL;
  bResult = (pv5 == pvnull); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bResult = (pv5 != pvnull); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bResult = (pv5 > pvnull); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bResult = (pv5 < pvnull); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bResult = (pvnull == pvnull); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bResult = (pvnull != pvnull); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bResult = (pvnull > pvnull); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bResult = (pvnull < pvnull); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26472)
  ATL::CComPropVariant pv7{static_cast<unsigned short>(1)};
#pragma warning(suppress: 26472)
  ATL::CComPropVariant pv8{static_cast<unsigned long>(1)};
#pragma warning(suppress: 26472)
  ATL::CComPropVariant pv9{static_cast<unsigned int>(1)};
  try
  {
    //ATL::CComPropVariant pv10{static_cast<unsigned int>(1), VT_DATE}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }
  ATL::CComPropVariant pv11{"Test"};
  ATL::CComPropVariant pv12{L"Test"};
  ATL::CComPropVariant pv13{pv12};
  PROPVARIANT pvRaw;
  PropVariantInit(&pvRaw);
  hr = pv13.Detach(&pvRaw); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));
  hr = pv13.Attach(&pvRaw); //NOLINT(clang-analyzer-deadcode.DeadStores)
  PropVariantInit(&pvRaw);
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));
  hr = pv13.Detach(&pvRaw); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));
  pv13 = pvRaw;
  //ATL::CComPropVariant pv14{pvRaw};
  ULARGE_INTEGER ul{};
  ul.QuadPart = 44;
  ATL::CComPropVariant pv14(ul);
  LARGE_INTEGER ll{};
  ll.QuadPart = 42;
  ATL::CComPropVariant pv15(ll);
  CY cy{};
  cy.int64 = 42;
  ATL::CComPropVariant pv16{cy};
  ATL::CComBSTR bstr{"hello"};
  ATL::CComPropVariant pv17{bstr};
  //pv17 = pv15;
  BSTR bstrVal{nullptr};
  hr = pv17.CopyTo(&bstrVal); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));
  SysFreeString(bstrVal);
#pragma warning(suppress: 26472)
  ATL::CComPropVariant pv18{static_cast<long>(1)};
#pragma warning(suppress: 26472)
  ATL::CComPropVariant pv18b{static_cast<long>(1), VT_ERROR};
  try
  {
    //ATL::CComPropVariant pv18c{1L, VT_UI1}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }
  ATL::CComPropVariant pv19{1.35};
  ATL::CComPropVariant pv20{1.35f};
#pragma warning(suppress: 26472)
  ATL::CComPropVariant pv20a{static_cast<short>(63)};
#pragma warning(suppress: 26472)
  ATL::CComPropVariant pv20b{static_cast<BYTE>(34)};
  try
  {
    //ATL::CComPropVariant pv21{1.35, VT_I4}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }
  try
  {
    //ATL::CComPropVariant pv22{1.35f, VT_I4}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }
  try
  {
    //ATL::CComPropVariant pv22{42L, VT_I1}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }
  FILETIME ft{};
  ft.dwHighDateTime = 1;
  ft.dwLowDateTime = 2;
  ATL::CComPropVariant pv23{ft};
  ATL::CComPropVariant pv24;
  pv24 = pv23;
  pv24 = true;
  pv24 = ft;
  pv24 = 24;
  pv24 = 'c';
#pragma warning(suppress: 26472)
  pv24 = static_cast<short>(42);
#pragma warning(suppress: 26472)
  pv24 = static_cast<long>(34);
  pv24 = 4.2;
  pv24 = 5.2f;
  pv24 = cy;
#pragma warning(suppress: 26472)
  pv24 = static_cast<unsigned short>(42);
#pragma warning(suppress: 26472)
  pv24 = static_cast<unsigned long>(42);
#pragma warning(suppress: 26472)
  pv24 = static_cast<unsigned int>(42);
  BYTE byVal{42};
  pv24 = &byVal;
  short nValue2{38};
  ATL::CComPropVariant pv1a{&nValue2};
  pv24 = &nValue2;
#pragma warning(suppress: 26465 26490 26492)
  auto pwsValue{reinterpret_cast<USHORT*>(const_cast<LPWSTR>(L"this is a test"))};
  pv24 = pwsValue;
  int nValue3{66};
  pv24 = &nValue3;
  UINT nValue4{63};
  pv24 = &nValue4;
  long nValue5a{21};
  pv24 = &nValue5a;
  ULONG nValue5b{54};
  pv24 = &nValue5b;
  LARGE_INTEGER nValue6{};
  nValue6.HighPart = 1;
  nValue6.LowPart = 2;
  pv24 = nValue6;
  ULARGE_INTEGER nValue7{};
  nValue7.HighPart = 1;
  nValue7.LowPart = 2;
  pv24 = nValue7;
  float fValue{6.1f};
  pv24 = &fValue;
  double dValue{2.56};
  pv24 = &dValue;
  BYTE byValue{56};
  pv24 = byValue;

  ATL::CComPtr<IUniformResourceLocator> pURL;
  hr = pURL.CoCreateInstance(CLSID_InternetShortcut, nullptr, CLSCTX_INPROC_SERVER); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));
  ATL::CComPropVariant pv25(pURL);

  ATL::CComPtr<IShellWindows> pShell;
  hr = pShell.CoCreateInstance(CLSID_ShellWindows, nullptr, CLSCTX_ALL); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));
  ATL::CComPropVariant pv26(pShell);

  ATL::CComPtr<IUniformResourceLocator> pURL2;
  hr = pURL2.CoCreateInstance(CLSID_InternetShortcut, nullptr, CLSCTX_INPROC_SERVER); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));
  pv25 = pURL2;
  pv25 = pShell;

  ATL::CComSafeArray<int> sa1{2, 0};
  sa1[0] = 3;
  sa1[1] = 1;
  ATL::CComPropVariant pv27{sa1};

  ATL::CComSafeArray<int> sa2{2, 0};
  sa2[0] = 4;
  sa2[1] = 2;
  pv27 = sa2;

  ATL::CComPropVariant pv34{L"A long string"};
  ATL::CComPropVariant pv35{"A long string"};
  pv34 = 12;
  pv34 = L"Another string";
  pv35 = 13;
  pv35 = L"Another long string";

  ATL::CComPtr<IStorage> pStorage;
  ATL::CComPropVariant pv36{pStorage};
  ATL::CComPropVariant pv36b{pStorage, VT_STORED_OBJECT};
  pv36 = 12;
  pv36 = pStorage;

  try
  {
    //ATL::CComPropVariant pv36c{pStorage, VT_I1}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }

#pragma warning(suppress: 26490)
  ATL::CComPropVariant pv36d{reinterpret_cast<IStream*>(pURL.p)};
#pragma warning(suppress: 26490)
  ATL::CComPropVariant pv36e{reinterpret_cast<IStream*>(pURL.p), VT_STREAMED_OBJECT};
  pv36d = 12;
  pv36d = reinterpret_cast<IStream*>(pURL2.p);

  try
  {
    //ATL::CComPropVariant pv36f{reinterpret_cast<IStream*>(pURL.p), VT_UI1}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }

  CY cy2{};
  cy2.int64 = 42;
  ATL::CComPropVariant pv37{&cy2};
  pv37 = 13;
  pv37 = &cy2;

  BYTE byValue2{4};
  ATL::CComPropVariant pv38{&byValue2};

  USHORT nValue5{6};
  ATL::CComPropVariant pv39{&nValue5};
  int nValue8{7};
  ATL::CComPropVariant pv40{&nValue8};
  UINT nValue9{8};
  ATL::CComPropVariant pv41{&nValue9};
  long nValue10{9};
  ATL::CComPropVariant pv42{&nValue10};
  ULONG nValue11{10};
  ATL::CComPropVariant pv43{&nValue11};
  float fValue12{10.1234f};
  ATL::CComPropVariant pv44{&fValue12};
  double dValue13{1.234};
  ATL::CComPropVariant pv45{&dValue13};
  ATL::CComPropVariant pv46{&dValue13, VT_DATE|VT_BYREF};

  try
  {
    //ATL::CComPropVariant pv47{&dValue13, VT_I1}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }

  //Test out the CComPropVariant2 class
  ATL::CComPropVariant2 pv47;
  ATL::CComPropVariant2 pv48{true};
#pragma warning(suppress: 26472)
  ATL::CComPropVariant2 pv49{static_cast<short>(43)};
  ATL::CComPropVariant2 pv50{12};
  ATL::CComPropVariant2 pv51{12.3};
  ATL::CComPropVariant2 pv52{12.4f};
  PROPVARIANT pv53;
  memset(&pv53, 0, sizeof(pv53));
  pv52.Detach(&pv53);
  pv52.Attach(&pv53);
  pv52.Detach(&pv53);
  ATL::CComPropVariant2 pv54{pv53};
  pv54 = 12;
  pv54 = pv53;
  pv54 = 13;
  pv54 = &pv53;
  ATL::CComPropVariant2 pv54a{&pv53};

#pragma warning(suppress: 26465 26492)
  ATL::CComPropVariant2 pv55{const_cast<LPSTR>("Mary had a little lamb")};
  pv55 = 12;
  pv55 = "Another animal";
  ATL::CAtlStringW sTemp3{L"Mary had a little lamb 2"};
  ATL::CComPropVariant2 pv56{sTemp3.GetBuffer(), VT_LPWSTR};
  sTemp3.ReleaseBuffer();
  ATL::CComBSTR bstr2{"This is a BSTR"};
  ATL::CComPropVariant2 pv57{bstr2, VT_BSTR};
#pragma warning(suppress: 26472)
  ATL::CComPropVariant2 pv58{static_cast<BYTE>(43)};
  ATL::CComPropVariant2 pv59{'C'};

  try
  {
    //ATL::CComPropVariant2 pv60{L"Mary had a little lamb 2", VT_UI1}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }

  std::array<PROPVARIANT, 2> pv61{};
#pragma warning(suppress: 26446)
  pv61[0].vt = VT_UI1;
#pragma warning(suppress: 26446)
  pv61[0].bVal = 49;
#pragma warning(suppress: 26446)
  pv61[1].vt = VT_I4;
#pragma warning(suppress: 26446)
  pv61[1].lVal = 49;
  ATL::CComPropVariant2 pv62{pv61.data(), 2};

  PROPVARIANT pv63;
  memset(&pv63, 0, sizeof(pv63));
  pv63.vt = VT_UI1;
  pv63.bVal = 50;
  ATL::CComPropVariant2 pv64{&pv63};

  std::array<LPCSTR, 2> szStrings{"String 1", "String 2"};
#pragma warning(suppress: 26465)
  ATL::CComPropVariant2 pv65{const_cast<LPSTR*>(szStrings.data()), 2};

  std::array<LPCWSTR, 2> szStrings2{ L"Wide String 1", L"Wide String 2" };
#pragma warning(suppress: 26465)
  ATL::CComPropVariant2 pv66{const_cast<LPWSTR*>(szStrings2.data()), 2};

  try
  {
    //ATL::CComPropVariant2 pv66b{const_cast<LPWSTR*>(szStrings2.data()), 2, VT_UI1}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }

  std::array<BSTR, 2> bstrs{SysAllocString(L"First BSTR"), SysAllocString(L"Second BSTR")};
  ATL::CComPropVariant2 pv67{bstrs.data(), 2, VT_VECTOR|VT_BSTR};
#pragma warning(suppress: 26446)
  SysFreeString(bstrs[0]);
#pragma warning(suppress: 26446)
  SysFreeString(bstrs[1]);

  BSTR bstr3{SysAllocString(L"BSTR")};
  ATL::CComPropVariant2 pv68{&bstr3};
  SysFreeString(bstr3);

  FILETIME ft2{};
  ft2.dwHighDateTime = 3;
  ft2.dwLowDateTime = 4;
  ATL::CComPropVariant2 pv69{ft2};

  try
  {
    //ATL::CComPropVariant2 pv70{12, VT_UI1}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }

  std::array<BYTE, 2> byBytes{ 1, 2 };
  ATL::CComPropVariant2 pv71{byBytes.data(), 2};
  std::array<char, 2> cChars{3, 4};
  ATL::CComPropVariant2 pv72{cChars.data(), 2};
  short nShort{89};
  ATL::CComPropVariant2 pv73{&nShort};

  try
  {
    //ATL::CComPropVariant2 pv75{&nShort, VT_UI1}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }

#pragma warning(suppress: 26472)
  ATL::CComPropVariant2 pv76{&nShort, static_cast<VARTYPE>(VT_I2|VT_BYREF)};
#pragma warning(suppress: 26472)
  ATL::CComPropVariant2 pv77{&nShort, static_cast<VARTYPE>(VT_BOOL|VT_BYREF)};
  std::array<short, 2> nShorts{1, 2};
  ATL::CComPropVariant2 pv76b{nShorts.data(), 2, VT_I2|VT_VECTOR};
  ATL::CComPropVariant2 pv77b{nShorts.data(), 2, VT_BOOL|VT_VECTOR};

  try
  {
    //ATL::CComPropVariant2 pv77b{nShorts.data(), 2, VT_UI1}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }

#pragma warning(suppress: 6225)
  std::array<long, 2> nLongs{1L, 2L};
  ATL::CComPropVariant2 pv78{nLongs.data(), 2, VT_I4|VT_VECTOR};
  ATL::CComPropVariant2 pv79{nLongs.data(), 2, VT_ERROR|VT_VECTOR};

  try
  {
    //ATL::CComPropVariant2 pv79b{nLongs.data(), 2, VT_UI1}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }

  std::array<unsigned long, 2> uLongs{1, 2};
  ATL::CComPropVariant2 pv80{uLongs.data(), 2};

  std::array<float, 2> fFloats{1.2f, 2.3f};
  ATL::CComPropVariant2 pv81{fFloats.data(), 2};

  std::array<double, 2> dblDoubles{1.2, 2.3};
  ATL::CComPropVariant2 pv82{dblDoubles.data(), 2};
  ATL::CComPropVariant2 pv83{dblDoubles.data(), 2, VT_DATE|VT_VECTOR};

  try
  {
    //ATL::CComPropVariant2 pv84{dblDoubles.data(), 2, VT_UI1}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }

  DECIMAL decimal{};
  decimal.scale = 3;
  decimal.sign = 0;
  decimal.Hi32 = 0;
  decimal.Lo64 = 123456;
  ATL::CComPropVariant2 pv85{decimal};
  ATL::CComPropVariant2 pv86{&decimal};
  pv86 = 3;
  pv86 = &decimal;
  pv86 = 4;
  pv86 = decimal;

  BLOB blob{};
  std::array<BYTE, 10> byData{0, 1, 2, 3, 4, 5, 6, 7, 8, 9};
  blob.cbSize = 10;
  blob.pBlobData = byData.data();
  ATL::CComPropVariant2 pv87{blob};
  pv87 = 46;
  pv87 = blob;

  BSTRBLOB bstrblob;
  bstrblob.cbSize = 10;
  bstrblob.pData = byData.data();
  ATL::CComPropVariant2 pv88{bstrblob};
  pv88 = 6;
  pv88 = bstrblob;

  LARGE_INTEGER nLarge{};
  nLarge.HighPart = 2;
  nLarge.LowPart = 3;
  ATL::CComPropVariant2 pv89{nLarge};

  ULARGE_INTEGER uLarge{};
  uLarge.HighPart = 2;
  uLarge.LowPart = 3;
  ATL::CComPropVariant2 pv90{uLarge};

  std::array<LARGE_INTEGER, 2> nLarges{};
#pragma warning(suppress: 26446)
  nLarges[0].HighPart = 2;
#pragma warning(suppress: 26446)
  nLarges[0].LowPart = 3;
#pragma warning(suppress: 26446)
  nLarges[1].HighPart = 4;
#pragma warning(suppress: 26446)
  nLarges[1].LowPart = 5;
  ATL::CComPropVariant2 pv91{nLarges.data(), 2};

  std::array<ULARGE_INTEGER, 2> uLarges{};
#pragma warning(suppress: 26446)
  uLarges[0].HighPart = 2;
#pragma warning(suppress: 26446)
  uLarges[0].LowPart = 3;
#pragma warning(suppress: 26446)
  uLarges[1].HighPart = 4;
#pragma warning(suppress: 26446)
  uLarges[1].LowPart = 5;
  ATL::CComPropVariant2 pv92{uLarges.data(), 2};

  long nLong{88};
  ATL::CComPropVariant2 pv93{nLong};
  ATL::CComPropVariant2 pv94{&nLong};

  try
  {
    //ATL::CComPropVariant2 pv96{&nLong, VT_UI1}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }

  ATL::CComPropVariant2 pv97{dValue13};
  ATL::CComPropVariant2 pv98{dValue13, VT_DATE};
  ATL::CComPropVariant2 pv99{&dValue13};
  ATL::CComPropVariant2 pv100{&dValue13, VT_DATE};

  try
  {
    //ATL::CComPropVariant2 pv101({dValue13, VT_UI1}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }

  std::array<BSTRBLOB, 2> bstrblobs{};
#pragma warning(suppress: 26446)
  bstrblobs[0].cbSize = 10;
#pragma warning(suppress: 26446)
  bstrblobs[0].pData = byData.data();
#pragma warning(suppress: 26446)
  bstrblobs[1].cbSize = 4;
#pragma warning(suppress: 26446)
  bstrblobs[1].pData = byData.data();
  ATL::CComPropVariant2 pv102{bstrblobs.data(), 2};

  ATL::CComPropVariant2 pv103{cy};
  ATL::CComPropVariant2 pv104{&cy};
  pv104 = 99;
  pv104 = &cy;

  std::array<CY, 2> cys{};
#pragma warning(suppress: 26446)
  cys[0].Hi = 1;
#pragma warning(suppress: 26446)
  cys[0].Lo = 2;
#pragma warning(suppress: 26446)
  cys[1].Hi = 3;
#pragma warning(suppress: 26446)
  cys[1].Lo = 4;
  ATL::CComPropVariant2 pv105{cys.data(), 2};

  pv105 = true;
  pv105 = ft;
  pv105 = 24;
  pv105 = 'c';
#pragma warning(suppress: 26472)
  pv105 = static_cast<short>(42);
#pragma warning(suppress: 26472)
  pv105 = static_cast<long>(34);
  pv105 = 4.2;
  pv105 = 5.2f;
  pv105 = cy;
#pragma warning(suppress: 26472)
  pv105 = static_cast<unsigned short>(42);
#pragma warning(suppress: 26472)
  pv105 = static_cast<unsigned long>(42);
#pragma warning(suppress: 26472)
  pv105 = static_cast<unsigned int>(42);
  pv105 = &byVal;
  pv105 = pwsValue;
  pv105 = &nValue3;
  pv105 = &nValue4;
  pv105 = &nValue5a;
  pv105 = &nValue5b;
  pv105 = nValue6;
  pv105 = nValue7;
  pv105 = &fValue;
  pv105 = &dValue;
  pv105 = byValue;
  pv105 = 66;
  hr = pv105.ChangeType(VT_I8); //NOLINT(clang-analyzer-deadcode.DeadStores)
  ATL::CComBSTR bstr5{"hello"};
  ATL::CComPropVariant2 pv105a{bstr5, VT_BSTR};
  hr = pv105a.CopyTo(&bstrVal); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(SUCCEEDED(hr));
  SysFreeString(bstrVal);
  ATL::CComPropVariant2 pv106{'c'};
#pragma warning(suppress: 26472)
  ATL::CComPropVariant2 pv107{static_cast<BYTE>(1)};
  bResult = (pv106 == pv107); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bResult = (pv106 != pv107); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bResult = (pv106 > pv107); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bResult = (pv106 < pv107); //NOLINT(clang-analyzer-deadcode.DeadStores)
  ATL::CComPropVariant2 pvnull2;
  pvnull2.vt = VT_NULL;
  bResult = (pv106 == pvnull2); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bResult = (pv106 != pvnull2); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bResult = (pv106 > pvnull2); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bResult = (pv106 < pvnull2); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bResult = (pvnull2 == pvnull2); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bResult = (pvnull2 != pvnull2); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bResult = (pvnull2 > pvnull2); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bResult = (pvnull2 < pvnull2); //NOLINT(clang-analyzer-deadcode.DeadStores)

  ATL::CComPropVariant2 pv108{&byValue};

  ATL::CComPropVariant2 pv109{pURL};
  ATL::CComPropVariant2 pv110{pShell};
  pv110 = pURL2;
  pv110 = pShell;

#pragma warning(suppress: 26490)
  ATL::CComPropVariant2 pv111{reinterpret_cast<IUnknown**>(&pURL.p)};
#pragma warning(suppress: 26490)
  ATL::CComPropVariant2 pv112{reinterpret_cast<IDispatch**>(&pShell.p)};
#pragma warning(suppress: 26490)
  pv112 = reinterpret_cast<IUnknown**>(&pURL2.p);
#pragma warning(suppress: 26490)
  pv112 = reinterpret_cast<IDispatch**>(&pShell.p);

#pragma warning(suppress: 26472)
  ATL::CComPropVariant2 pv113{static_cast<unsigned short>(12)};
#pragma warning(suppress: 26472)
  ATL::CComPropVariant2 pv114{static_cast<unsigned long>(12)};

  CLSID clsid{CLSID_InternetShortcut};
  ATL::CComPropVariant2 pv115{&clsid};
  pv115 = 42;
  pv115 = &clsid;

  std::array<CLSID, 2> clsids{CLSID_InternetShortcut, CLSID_DOMDocument};
  ATL::CComPropVariant2 pv116{clsids.data(), 2};

  CLIPDATA cd{};
  cd.cbSize = sizeof(cd)+sizeof(byData);
  cd.ulClipFmt = 42;
  cd.pClipData = byData.data();
  ATL::CComPropVariant2 pv117(&cd);

  std::array<CLIPDATA, 2> cds{};
#pragma warning(suppress: 26446)
  cds[0].cbSize = sizeof(cd)+sizeof(byData);
#pragma warning(suppress: 26446)
  cds[0].ulClipFmt = 42;
#pragma warning(suppress: 26446)
  cds[0].pClipData = byData.data();
#pragma warning(suppress: 26446)
  cds[1].cbSize = sizeof(cd)+5;
#pragma warning(suppress: 26446)
  cds[1].ulClipFmt = 43;
#pragma warning(suppress: 26446)
  cds[1].pClipData = byData.data();
  ATL::CComPropVariant2 pv118{cds.data(), 2};
  pv118 = &cd;
  ATL::CComPropVariant2 pv119{&nValue4};
  pv119 = 78;
  pv119 = &nValue4;

  int nValue{38};
  ATL::CComPropVariant2 pv120{&nValue};
  pv120 = 67;
  pv120 = &nValue;

  USHORT uValue{39};
  ATL::CComPropVariant2 pv121{&uValue};
  pv121 = 68;
  pv121 = &uValue;

#pragma warning(suppress: 26490)
  ATL::CComPropVariant2 pv122{reinterpret_cast<IStorage*>(pURL.p)};
#pragma warning(suppress: 26490)
  ATL::CComPropVariant2 pv122b{reinterpret_cast<IStorage*>(pURL.p), VT_STORED_OBJECT};

  try
  {
    //ATL::CComPropVariant2 pv122c{reinterpret_cast<IStorage*>(pURL.p), VT_UI1}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }

  pv122 = 12;
  pv122 = reinterpret_cast<IStorage*>(pURL2.p);
#pragma warning(suppress: 26490)
  ATL::CComPropVariant2 pv123{reinterpret_cast<IStream*>(pURL.p)};
#pragma warning(suppress: 26490)
  ATL::CComPropVariant2 pv123b{reinterpret_cast<IStream*>(pURL.p), VT_STREAMED_OBJECT};
  pv123 = 12;
  pv123 = reinterpret_cast<IStream*>(pURL2.p);

  try
  {
    //ATL::CComPropVariant2 pv123c{reinterpret_cast<IStream*>(pURL.p), VT_UI1}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }

  VERSIONEDSTREAM vs{};
  vs.guidVersion = CLSID_InternetShortcut;
#pragma warning(suppress: 26490)
  vs.pStream = reinterpret_cast<IStream*>(pURL.p);
  ATL::CComPropVariant2 pv124{&vs};
  pv124 = 12;
  pv124 = &vs;

  ATL::CComSafeArray<int> sa3{2, 0};
  sa3[0] = 4;
  sa3[1] = 5;
  ATL::CComPropVariant2 pv125{&sa3.m_psa};
  pv125 = 66;
  pv125 = &sa3.m_psa;
  ATL::CComPropVariant2 pv126{sa3.m_psa};
  pv126 = 67;
  pv126 = sa3.m_psa;

  ATL::CComPropVariant2 pv127{&fValue};
  pv127 = 321;
  pv127 = &fValue;

  std::array<FILETIME, 2> fts{};
#pragma warning(suppress: 26446)
  fts[0].dwHighDateTime = 1;
#pragma warning(suppress: 26446)
  fts[0].dwLowDateTime = 2;
#pragma warning(suppress: 26446)
  fts[1].dwHighDateTime = 3;
#pragma warning(suppress: 26446)
  fts[1].dwLowDateTime = 4;
  ATL::CComPropVariant2 pv128{fts.data(), 2};
  pv128 = 101;

  ATL::CComPropVariant2 pv129{&nValue5b};
  pv129 = 102;
  pv129 = &nValue5b;

  constexpr const unsigned int uInt{12};
  ATL::CComPropVariant2 pv130(uInt);
  pv129 = 102;
  pv129 = uInt;

  try
  {
    //ATL::CComPropVariant2 pv131{uInt, VT_UI1}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }

  ATL::CComPropVariant2 pv132{nValue5a, VT_ERROR};
  try
  {
    //ATL::CComPropVariant2 pv133{nValue5a, VT_UI1}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }

  short nValue12{38};
#pragma warning(suppress: 26472)
  ATL::CComPropVariant2 pv134{&nValue12, static_cast<VARTYPE>(VT_BOOL|VT_BYREF)};
  pv134 = 12;

  std::array<unsigned short, 2> uShorts{1, 2};
  ATL::CComPropVariant2 pv135{uShorts.data(), 2};

  long nLong2{12};
#pragma warning(suppress: 26472)
  ATL::CComPropVariant2 pv136{&nLong2, static_cast<VARTYPE>(VT_ERROR|VT_BYREF)};

  try
  {
    //ATL::CComPropVariant2 pv137{&nLong2, static_cast<VARTYPE>(VT_UI1)}; //Uncomment to test out the error handling
  }
#ifdef _AFX
  catch (CException* pEx)
  {
    pEx->Delete();
  }
#endif
  catch (ATL::CAtlException& /*e*/)
  {
  }

  hr = q1.PathNameToFormatName(L".\\Private$\\MSMQDemo", sFormatName);
  if (SUCCEEDED(hr))
    hr = q1.Delete(sFormatName.c_str()); //NOLINT(clang-analyzer-deadcode.DeadStores)

  CoUninitialize();

  return 0;
}
